% input:
% akk: new input sample
% ykk: new target sample
% Pk: old matrix (A'A)^-1
% thetak: old weights

% output:
% Pkk: new matrix (A'A)^-1
% thetakk: new weights


function [thetakk,Pkk] = AdaptiveOrdinaryLeastSquareV3(akk,ykk,thetak,Pk,gamma,lambda)
    %Pkk = Pk - (Pk*(akk*akk')*Pk)/(1+akk'*Pk*akk);
%     if(nargin==4)
%         lambda = 1;
%     end
    Pkk = (1/lambda)* (Pk - (gamma*Pk*(akk*akk')*Pk)/(lambda+gamma*akk'*Pk*akk));
    thetakk = thetak + gamma*Pkk*akk*(ykk - akk'*thetak);
end