
function [thetakk,Pkk,ActualMeanPi_k,beta,Q] = mulrm_update(X,Y,thetakk,Pkk,ActualMeanPi_k,beta,SW)

% Forgetting factor
% SW =50;
lambda=((SW-1)+0.0001)/SW;
% lambda = SW;
N = length(X);
% lambda=0.99;

% calcula responsabilidades de cada modelo
for j=1:N % calcula o erro quadratico de cada modelo
    aux_yyy(j) = [1 X(j)]*thetakk{j};
    probk(j) = normpdf(Y,aux_yyy(j),sqrt(beta(j))+eps);
end

denn = ActualMeanPi_k*probk';
for j=1:N % compute weights
    pi_k(j) = (ActualMeanPi_k(j)*probk(j))/(denn+eps);
end

% calcula likelihood function
Q  =0;
for j=1:N % compute weights
    Q = Q + log(pi_k(j)*probk(j)+eps);
end

% Atualiza parametro dos modelos
ActualMeanPi_k = adaptiveMean(pi_k,ActualMeanPi_k,lambda,2);

% Atualiza modelos utilizando os pelos pi_k
for j=1:length(X)
    [thetakk{j},Pkk{j}] = AdaptiveOrdinaryLeastSquareV3...
        ([1 X(j)]',Y,thetakk{j},Pkk{j},pi_k(j),lambda);
end

% Atualiza variancia
for j=1:length(X) % calcula o erro quadratico de cada modelo
    % -- working
    aux_yyy = [1 X(j)]*thetakk{j};
    errorEachModel(j) = (aux_yyy - Y).^2; % compute the atual error
    error_plus_peso(:,j) =  pi_k(j)*errorEachModel(:,j)/(SW*ActualMeanPi_k(j));
    
    % -- testing
    % aux_yyy = [1 X(j)]*thetakk{j};
    % errorEachModel(j) = pi_k(j)*(aux_yyy - Y).^2; % compute the atual error
    %error_plus_peso(:,j) =  pi_k(j)*errorEachModel(:,j)/(SW*ActualMeanPi_k(j));
    
end

% --working
beta = adaptiveMean(errorEachModel,beta,lambda,2);

% -- testing
% beta = adaptiveMean(errorEachModel2,beta,lambda,2);


end
